"""
Django settings for CBF project.

Generated by 'django-admin startproject' using Django 1.11.7.

For more information on this file, see
https://docs.djangoproject.com/en/1.11/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.11/ref/settings/
"""

import os
from django.conf.locale.es import formats as es_formats

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))
PROJECT_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
TMP_DIR = os.path.join(PROJECT_DIR, 'tmp')

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = '4u_1p097pct!c$)kk$*k0^les8!x@k1q=4@1jz6mrsr@yd%523'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = ['*']

SITE_ID = 1



# **************************************************************************
# Applications
# **************************************************************************

CUSTOM_APPS = [
    'pgp.contrib.theme',
    'pgp.contrib.jobs',
    'pgp.cots',

]
CONTRIB_APPS = [
    'reversion',
    'django_admin_listfilter_dropdown',
    'massadmin',
    'easy_select2',
    'rangefilter',
#    'django_mailbox',
#    'social_django',
    'adminsortable2',
    'import_export', 
#    'admin_comments',
    'rest_framework',
]
DJANGO_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'django.contrib.sites',
]

INSTALLED_APPS = CUSTOM_APPS + CONTRIB_APPS + DJANGO_APPS


MIDDLEWARE  = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'django.middleware.locale.LocaleMiddleware',
    'django.contrib.admindocs.middleware.XViewMiddleware',
]

ROOT_URLCONF = 'pgp.urls'



# **************************************************************************
#   Templates
# **************************************************************************
TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,        
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]


# **************************************************************************
#   Deployment / Installation /Execution Environment
# **************************************************************************
WSGI_APPLICATION = 'pgp.wsgi.application'


# **************************************************************************
#   REST API
# **************************************************************************
REST_FRAMEWORK = {
    # Use Django's standard `django.contrib.auth` permissions,
    # or allow read-only access for unauthenticated users.
    'DEFAULT_PERMISSION_CLASSES': [
        'rest_framework.permissions.DjangoModelPermissionsOrAnonReadOnly'
    ]
}


# **************************************************************************
#   Database
# **************************************************************************
# https://docs.djangoproject.com/en/1.11/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': os.path.join(BASE_DIR, 'db', 'db.sqlite3'),
    }
}



# **************************************************************************
#   Authentication
# **************************************************************************
# https://docs.djangoproject.com/en/1.11/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]
AUTH_PASSWORD_VALIDATORS = []

AUTHENTICATION_BACKENDS = (
    'social_core.backends.google.GoogleOAuth2',
    'django.contrib.auth.backends.ModelBackend',
)

LOGIN_URL = '/auth/login/google-oauth2/'

LOGIN_REDIRECT_URL = '/admin'
LOGOUT_REDIRECT_URL = '/'

SOCIAL_AUTH_GOOGLE_OAUTH2_KEY = '924692487239-mshcd11tlccd4i5ru154rbo2f8rkqgn9.apps.googleusercontent.com'
SOCIAL_AUTH_GOOGLE_OAUTH2_SECRET = 'p2N3vwci4Y5uyS8HezUJaNH0'

SOCIAL_AUTH_URL_NAMESPACE = 'social'

# **************************************************************************
#   Internationalization
# **************************************************************************
# https://docs.djangoproject.com/en/1.11/topics/i18n/

LANGUAGE_CODE = 'es-ES'
TIME_ZONE = 'UTC'
USE_I18N = True
USE_L10N = True
USE_TZ = True

es_formats.DATE_FORMAT = "d/m/y"

gettext = lambda s: s
LANGUAGES = (
    ('es', gettext('Spanish')),
)

# where to save generated translation files (*.po)
LOCALE_PATHS = (
    os.path.join(PROJECT_DIR, 'locale'),
)



# **************************************************************************
# STATIC FILES
# **************************************************************************
# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.11/howto/static-files/

STATICFILES_FINDERS = [
    'django.contrib.staticfiles.finders.AppDirectoriesFinder',
]

# WHERE to PUT static files in. Static files will be served from this path
# Path relative to Django root folder
STATIC_ROOT = 'static'

# URL for static files
# This is used by the `static` template tag from `static`, if you're using that. Or if anything else
# refers directly to STATIC_URL. So it's safest to always set it.
# Using {% static 'staticfile.css' %} will transform to STATIC_URL/static_file.css
STATIC_URL = '/static/'
